Skip to content

CSPM Registration

The CSPM Registration service collection provides operations for registering and managing cloud accounts across AWS, Azure, and GCP environments. Configure cloud security posture monitoring, manage policy settings, and schedule compliance scans across your multi-cloud infrastructure.

LanguageLast Update
Pythonv1.5.4
PowerShellv2.2.9
Gov0.20.0
TypeScriptv0.6.0
Rustv0.7.0
Rubyv1.2.0
Sample Code
OperationDescription
GetCSPMAwsAccount
get_aws_account
Returns information about the current status of an AWS account.
CreateCSPMAwsAccount
create_aws_account
Creates a new account in our system for a customer and generates a script for them to run in their AWS cloud environment to grant us access.
DeleteCSPMAwsAccount
delete_aws_account
Deletes an existing AWS account or organization in our system.
PatchCSPMAwsAccount
update_aws_account
Patches a existing account in our system for a customer.
GetCSPMAwsConsoleSetupURLs
get_aws_console_setup_urls
Return a URL for customer to visit in their cloud environment to grant us access to their AWS environment.
GetCSPMAwsAccountScriptsAttachment
get_aws_account_scripts_attachment
Return a script for customer to run in their cloud environment to grant us access to their AWS environment as a downloadable attachment.
GetCSPMAzureAccount
get_azure_account
Return information about Azure account registration
CreateCSPMAzureAccount
create_azure_account
Creates a new account in our system for a customer and generates a script for them to run in their cloud environment to grant us access.
DeleteCSPMAzureAccount
delete_azure_account
Deletes an Azure subscription from the system.
UpdateCSPMAzureAccountClientID
update_azure_account_client_id
Update an Azure service account in our system by with the user-created client_id created with the public key we’ve provided
UpdateCSPMAzureTenantDefaultSubscriptionID
update_azure_tenant_default_subscription_id
Update an Azure default subscription_id in our system for given tenant_id
AzureDownloadCertificate
azure_download_certificate
Returns JSON object(s) that contain the base64 encoded certificate for a service principal.
AzureRefreshCertificate
azure_refresh_certificate
Refresh certificate and returns JSON object(s) that contain the base64 encoded certificate for a service principal.
GetCSPMAzureUserScriptsAttachment
get_azure_user_scripts_attachment
Return a script for customer to run in their cloud environment to grant us access to their Azure environment as a downloadable attachment
GetBehaviorDetections
get_behavior_detections
Retrieve a list of detected behaviors.
GetConfigurationDetections
get_configuration_detections
Retrieve a list of active misconfigurations.
GetConfigurationDetectionEntities
get_configuration_detection_entities
Get misconfigurations based on the ID - including custom policy detections in addition to default policy detections.
GetConfigurationDetectionIDsV2
get_configuration_detection_ids_v2
Get a list of active misconfiguration ids - including custom policy detections in addition to default policy detections.
GetCSPMPolicy
get_policy
Given a policy ID, returns detailed policy information.
GetCSPMPoliciesDetails
get_policy_details
Given an array of policy IDs, returns detailed policies information.
GetCSPMPolicySettings
get_policy_settings
Returns information about current policy settings.
UpdateCSPMPolicySettings
update_policy_settings
Updates a policy setting - can be used to override policy severity or to disable a policy entirely.
GetCSPMScanSchedule
get_scan_schedule
Returns scan schedule configuration for one or more cloud platforms.
UpdateCSPMScanSchedule
update_scan_schedule
Updates scan schedule configuration for one or more cloud platforms.
GetCSPMAzureManagementGroup
get_azure_management_group
Return information about Azure management group registration
DeleteCSPMAzureManagementGroup
delete_azure_management_group
Deletes Azure management groups from the system.
CreateCSPMAzureManagementGroup
create_azure_management_group
Creates a new management group in our system for a customer.
CreateCSPMGCPAccount
create_gcp_account
Creates a new account in our system for a customer and generates a new service account for them to add access to in their GCP environment to grant us access.
deprecated
DeleteCSPMGCPAccount
delete_gcp_account
Deletes a GCP account from the system.
deprecated
UpdateCSPMGCPAccount
update_gcp_account
Patches a existing account in our system for a customer.
deprecated
ConnectCSPMGCPAccount
connect_gcp_account
Creates a new GCP account with newly-uploaded service account or connects with existing service account with only the following fields: parent_id, parent_type and service_account_id
deprecated
GetCSPMGCPServiceAccountsExt
get_gcp_service_account
Returns the service account id and client email for external clients.
deprecated
UpdateCSPMGCPServiceAccountsExt
update_gcp_service_account
Updates an existing GCP service account.
deprecated
GetCSPMGCPUserScriptsAttachment
get_gcp_user_scripts_attachment
Return a script for customer to run in their cloud environment to grant us access to their GCP environment as a downloadable attachment
deprecated
GetCSPMGCPValidateAccountsExt
validate_gcp_account
Run a synchronous health check.
deprecated
ValidateCSPMGCPServiceAccountExt
validate_gcp_service_account
Validates credentials for a service account
deprecated
GetCSPMCGPAccount
get_gcp_account
Returns information about the current status of an GCP account.
UpdateCSPMAzureAccount
update_azure_account
Patches a existing account in our system for a customer.
getCloudEventIDs
get_cloud_event_ids
Get list of related cloud event LogScale IDs for a given IOA

Returns information about the current status of an AWS account.

GET /cloud-connect-cspm-aws/entities/account/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_aws_account
NameTypeData typeDescription
cspm_litequerybooleanOnly return CSPM lite accounts.
group_byquerystringThe field to group by.
idsquerystring or list of stringsAWS Account ID(s).
iam_role_arnsquerystring or list of stringsAWS IAM role ARN(s).
limitqueryintegerMaximum number of results to return. (Default: 100)
migratedquerystringOnly return migrated D4C accounts (true or false).
offsetqueryintegerStarting record position.
organization_idsquerystring or list of stringsAWS Organization ID(s).
parametersquerydictionaryFull query string parameters payload in JSON format.
scan_typequerystringType of scan to perform, dry or full.
statusquerystringAccount status to filter results by.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_aws_account(scan_type="string",
cspm_lite=boolean,
ids=id_list,
iam_role_arns=id_list,
organization_ids=id_list,
limit=integer,
migrated="string",
offset=integer,
status="string",
group_by="string")
print(response)

Creates a new account in our system for a customer and generates a script for them to run in their AWS cloud environment to grant us access.

POST /cloud-connect-cspm-aws/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 create_aws_account
NameTypeData typeDescription
account_idbodystringAWS Account ID.
account_typebodystringAWS Account Type.
behavior_assessment_enabledbodybooleanFlag indicating if behavior assessment should be enabled.
bodybodydictionaryFull body payload in JSON format.
cloudtrail_regionbodystringAWS Cloudtrail Region.
iam_role_arnbodystringAWS IAM Role ARN.
is_masterbodybooleanFlag indicating this is the master account.
organization_idbodystringAWS Organization ID.
sensor_management_enabledbodybooleanFlag indicating if sensor management should be enabled.
use_existing_cloudtrailbodybooleanFlag indicating if the existing CloudTrail log should be used.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.create_aws_account(account_id="string",
account_type="string",
behavior_assessment_enabled=boolean,
cloudtrail_region="string",
deployment_method="string",
dspm_enabled=boolean,
dspm_role="string",
falcon_client_id="string",
iam_role_arn="string",
is_master=boolean,
organization_id="string",
root_stack_id="string",
sensor_management_enabled=boolean,
target_ous=id_list,
use_existing_cloudtrail=boolean)
print(response)

Deletes an existing AWS account or organization in our system.

DELETE /cloud-connect-cspm-aws/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 delete_aws_account
NameTypeData typeDescription
idsquerystring or list of stringsThe AWS account IDs to remove.
organization_idsquerystring or list of stringsThe AWS organization ID(s) to delete.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_aws_account(ids=id_list, organization_ids=id_list)
print(response)

Patches a existing account in our system for a customer.

PATCH /cloud-connect-cspm-aws/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 update_aws_account
NameTypeData typeDescription
account_idbodystringAWS Account ID.
behavior_assessment_enabledbodybooleanFlag indicating if behavior assessment should be enabled.
bodybodydictionaryFull body payload in JSON format.
cloudtrail_regionbodystringAWS Cloudtrail Region.
iam_role_arnbodystringAWS IAM Role ARN.
remediation_regionbodystringRegion where remediation occurs.
remediation_tou_acceptedbodystringThe accepted TOU for this account.
sensor_management_enabledbodybooleanFlag indicating if sensor management should be enabled.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_aws_account(account_id="string",
behavior_assessment_enabled=boolean,
cloudtrail_region="string",
iam_role_arn="string",
remediation_region="string",
remediation_tou_accepted="string",
cloudtrail_region="string")
print(response)

Return a URL for customer to visit in their cloud environment to grant us access to their AWS environment.

GET /cloud-connect-cspm-aws/entities/console-setup-urls/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_aws_console_setup_urls
NameTypeData typeDescription
idsquerystring or list of stringsThe AWS account ID(s) to retrieve setup URLs.
parametersquerydictionaryFull query string parameters payload in JSON format.
regionquerystringRegion
tagsquerystringBase64 encoded JSON string to be used as AWS tags.
templatequerystringTemplate to be rendered. Available values: aws-url, aws-iom-url, aws-ioa-url, aws-sensor-management-url, aws-dspm-url, aws-idp-url, aws-modular-cft-url, and aws-modular-cft-gov-commercial-url
use_existing_cloudtrailquerystringBoolean flag indicating if the CloudTrail be used. (Accepted values: true or false)
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_aws_console_setup_urls(ids=id_list,
use_existing_cloudtrail="string",
region="string",
tags="string",
template="string")
print(response)

Return a script for customer to run in their cloud environment to grant us access to their AWS environment as a downloadable attachment.

GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_aws_account_scripts_attachment
NameTypeData typeDescription
accountsquerystring or list of stringsList of accounts to register.
account_typequerystringThe account type (commercial or gov).
aws_profilequerystringThe AWS profile to be used during registration.
behavior_assessment_enabledquerystringEnable behavior assessment. Allowed values: true or false
custom_role_namequerystringThe custom IAM role to be used during registration.
dspm_enabledquerystringEnable DSPM. Allowed values: true or false
dspm_regionsquerystring or list of stringsDSPM regions.
dspm_rolequerystringDSPM role.
idsquerystring or list of stringsThe AWS account ID(s) to retrieve script attachments.
organization_idquerystring or list of stringsThe AWS organization ID to be registered.
parametersquerydictionaryFull query string parameters payload as a dictionary.
sensor_management_enabledquerystringEnable sensor management. Allowed values: true or false
templatequerystringTemplate to be rendered. Allowed values: aws-bash or aws-terraform
use_existing_cloudtrailquerystringUse the existing cloudtrail log. Allowed values: true or false

Examples coming soon.


Return information about Azure account registration

GET /cloud-connect-azure/entities/account/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_azure_account
NameTypeData typeDescription
cspm_litequerybooleanOnly return CSPM lite accounts.
idsquerystring or list of stringsSubscription ID(s). When empty, all accounts are returned.
limitqueryintegerMaximum number of results to return. (Default: 100)
offsetqueryintegerStarting record position.
parametersquerydictionaryFull query string parameters payload in JSON format.
scan_typequerystringType of scan to perform, dry or full.
statusquerystringAccount status to filter results by. Allowed values: Event_DiscoverAccountStatusProvisioned, Event_DiscoverAccountStatusOperational
tenant_idsquerystring or list of stringsTenant ID(s) used to filter Azure accounts returned.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_azure_account(scan_type="string",
cspm_lite=boolean,
ids=id_list,
limit=integer,
offset=integer,
status="string",
tenant_ids=id_list)
print(response)

Creates a new account in our system for a customer and generates a script for them to run in their cloud environment to grant us access.

POST /cloud-connect-azure/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 create_azure_account
NameTypeData typeDescription
account_typebodystringAzure account type.
bodybodydictionaryFull body payload in JSON format.
client_idbodystringClient ID.
default_subscriptionbodybooleanFlag indicating if this is the default Azure subscription.
subscription_idbodystringAzure Subscription ID.
tenant_idbodystringAzure tenant ID.
years_validbodyintegerYears valid.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.create_azure_account(account_type="string",
client_id="string",
default_subscription=boolean,
subscription_id="string",
tenant_id="string",
years_valid=integer)
print(response)

Deletes an Azure subscription from the system.

DELETE /cloud-connect-cspm-azure/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 delete_azure_account
NameTypeData typeDescription
idsquerystring or list of stringsAzure subscription IDs to remove.
parametersquerydictionaryFull query string parameters payload in JSON format.
retain_tenantquerystringRetain tenant.
tenant_idsquerystring or list of stringsTenant IDs to remove.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_azure_account(ids=id_list,
retain_tenant="string",
tenant_ids=id_list)
print(response)

Update an Azure service account in our system by with the user-created client_id created with the public key we’ve provided

PATCH /cloud-connect-azure/entities/client-id/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 update_azure_account_client_id
NameTypeData typeDescription
bodybodystringThis field is not used. Ignore.
idquerystring or list of stringsThe Azure Client ID to use for the Service Principal associated with the Azure account.
tenant_idquerystring or list of stringsThe Azure tenant ID to update the Client ID for. Required if multiple tenants are registered.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.update_azure_account_client_id(id=id_list, tenant_id="string")
print(response)

UpdateCSPMAzureTenantDefaultSubscriptionID

Section titled “UpdateCSPMAzureTenantDefaultSubscriptionID”

Update an Azure default subscription_id in our system for given tenant_id

PATCH /cloud-connect-cspm-azure/entities/default-subscription-id/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 update_azure_tenant_default_subscription_id
NameTypeData typeDescription
bodybodystringThis field is not used. Ignore.
subscription_idquerystring or list of stringsThe Azure subscription ID to use as a default for all subscriptions within the tenant.
tenant_idquerystring or list of stringsThe Azure tenant ID to update the Client ID for. Required if multiple tenants are registered.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_azure_tenant_default_subscription_id(subscription_id="string",
tenant_id="string")
print(response)

Returns JSON object(s) that contain the base64 encoded certificate for a service principal.

GET /cloud-connect-cspm-azure/entities/download-certificate/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 azure_download_certificate
NameTypeData typeDescription
parametersquerydictionaryFull query string parameters payload in JSON format.
tenant_idquerystring or list of stringsThe Azure Client ID to generate script for. Defaults to the most recently registered tenant.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
with open("output_file", "wb") as save_file:
response = falcon.azure_download_certificate(tenant_id="string", stream=boolean)
save_file.write(response)

Refresh certificate and returns JSON object(s) that contain the base64 encoded certificate for a service principal.

POST /cloud-connect-cspm-azure/entities/refresh-certificate/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 azure_refresh_certificate
NameTypeData typeDescription
parametersquerydictionaryFull query string parameters payload in JSON format.
tenant_idquerystring or list of stringsAzure Tenant ID.
years_validquerystringYears the certificate should be valid. Max: 2, Default: 1
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
with open("output_file", "wb") as save_file:
response = falcon.azure_refresh_certificate(tenant_id="string",
years_valid=integer,
stream=boolean)
save_file.write(response)

Return a script for customer to run in their cloud environment to grant us access to their Azure environment as a downloadable attachment

GET /cloud-connect-azure/entities/user-scripts-download/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_azure_user_scripts_attachment
NameTypeData typeDescription
account_typequerystringAccount type (gov or commercial).
azure_management_groupquerybooleanUse Azure Management Group.
parametersquerydictionaryFull query string parameters payload in JSON format.
subscription_idsquerystring or list of stringsSubscription IDs to generate scripts for. Defaults to all.
templatequerystring or list of stringsTemplate to be rendered.
tenant_idquerystringThe Azure tenant ID to generate scripts for. Defaults to the most recently registered tenant.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
with open("output_file", "wb") as save_file:
response = falcon.get_azure_user_scripts_attachment(account_type="string",
azure_management_group=boolean,
tenant_id="string",
subscription_ids=id_list,
template="string",
stream=boolean)
save_file.write(response)

Retrieve list of detected behaviors.

GET /detects/entities/ioa/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_behavior_detections
NameTypeData typeDescription
account_idquerystringCloud account ID (e.g.: AWS AccountID, Azure SubscriptionID).
aws_account_idquerystringAWS Account ID.
azure_subscription_idquerystringAzure Subscription ID.
azure_tenant_idquerystringAzure Tenant ID.
cloud_providerquerystringCloud Provider (azure, aws, gcp).
date_time_sincequerystringFilter to retrieve all events after specified date. RFC3339 format. Example: 2006-01-01T12:00:01Z07:00.
limitqueryintegerMaximum number of results to return. (Max: 500)
next_tokenquerystringString to get next page of results, associated with the previous execution. Must include all filters from previous execution.
parametersquerydictionaryFull query string parameters payload in JSON format.
resource_idquerystring or list of stringsResource ID.
resource_uuidquerystring or list of stringsResource UUID.
servicequerystringFilter by Cloud Service. See Available Services table below.
severityquerystringFilter by severity. Example: High, Medium or Informational.
statequerystringFilter by state. Example: open or closed.
ACMIdentity
ACRKMS
AnyKeyVault
App EngineKinesis
BigQueryKubernetes
Cloud Load BalancingLambda
Cloud LoggingLoadBalancer
Cloud SQLMonitor
Cloud StorageNLB/ALB
CloudFormationNetworkSecurityGroup
CloudTrailPostgreSQL
CloudWatch LogsRDS
CloudfrontRedshift
Compute EngineS3
ConfigSES
DiskSNS
DynamoDBSQLDatabase
EBSSQLServer
EC2SQS
ECRSSM
EFSServerless Application Repository
EKSStorageAccount
ELBSubscriptions
EMRVPC
ElasticacheVirtualMachine
GuardDutyVirtualNetwork
IAM
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_behavior_detections(account_id="string",
aws_account_id="string",
azure_subscription_id="string",
azure_tenant_id="string",
cloud_provider="string",
date_time_since="string",
limit=integer,
next_token="string",
resource_id="string",
service="string",
severity="string",
since="string",
state="string")
print(response)

Retrieve list of detected behaviors.

GET /detects/entities/iom/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_configuration_detections
NameTypeData typeDescription
account_idquerystringCloud account ID (e.g.: AWS AccountID, Azure SubscriptionID).
aws_account_idquerystringAWS Account ID.
azure_subscription_idquerystringAzure Subscription ID.
azure_tenant_idquerystringAzure Tenant ID.
cloud_providerquerystringCloud Provider (azure, aws, gcp).
limitqueryintegerMaximum number of results to return. (Max: 500)
next_tokenquerystringString to get next page of results, associated with the previous execution. Must include all filters from previous execution.
parametersquerydictionaryFull query string parameters payload in JSON format.
regionquerystringCloud Provider Region. Example: us-east-1.
servicequerystringFilter by Cloud Service. See Available Services table below.
severityquerystringFilter by severity. Example: High, Medium or Informational.
statusquerystringFilter by status. Example: new, reoccurring or all.
ACMIdentity
ACRKMS
AnyKeyVault
App EngineKinesis
BigQueryKubernetes
Cloud Load BalancingLambda
Cloud LoggingLoadBalancer
Cloud SQLMonitor
Cloud StorageNLB/ALB
CloudFormationNetworkSecurityGroup
CloudTrailPostgreSQL
CloudWatch LogsRDS
CloudfrontRedshift
Compute EngineS3
ConfigSES
DiskSNS
DynamoDBSQLDatabase
EBSSQLServer
EC2SQS
ECRSSM
EFSServerless Application Repository
EKSStorageAccount
ELBSubscriptions
EMRVPC
ElasticacheVirtualMachine
GuardDutyVirtualNetwork
IAM
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_configuration_detections(account_id="string",
aws_account_id="string",
azure_subscription_id="string",
azure_tenant_id="string",
cloud_provider="string",
limit=integer,
next_token="string",
region="string",
service="string",
severity="string",
status="string")
print(response)

Get misconfigurations based on the ID - including custom policy detections in addition to default policy detections.

GET /detects/entities/iom/v2
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_configuration_detection_entities
NameTypeData typeDescription
idsquerystring or list of stringsDetection IDs to retrieve.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_configuration_detection_entities(ids=id_list)
print(response)

Get a list of active misconfiguration ids - including custom policy detections in addition to default policy detections.

GET /detects/queries/iom/v2
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_configuration_detection_ids_v2
NameTypeData typeDescription
filterquerystringThe FQL filter expression that should be used to limit the results. Available filters: use_current_scan_ids, account_name, account_id, agent_id, attack_types, azure_subscription_id, cloud_provider, cloud_service_keyword, custom_policy_id, is_managed, policy_id, policy_type, resource_id, region, status, scan_time, severity, severity_string
limitqueryintegerThe maximum number of detections to return. [1-1000]
next_tokenquerystringString to get next page of results. Cannot be combined with any other keyword except limit.
offsetqueryintegerThe offset to start retrieving detections from
parametersquerydictionaryFull query string parameters payload in JSON format.
sortquerystringThe property to sort by (e.g. timestamp|desc or policy_id|asc). Default: timestamp|desc. Available fields: account_name, account_id, attack_types, azure_subscription_id, cloud_provider, cloud_service_keyword, status, is_managed, policy_id, policy_type, resource_id, region, scan_time, severity, severity_string, timestamp
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_configuration_detection_ids_v2(filter="string",
limit=integer,
next_token="string",
offset=integer,
sort="string")
print(response)

Given a policy ID, returns detailed policy information.

GET /settings/entities/policy-details/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_policy
NameTypeData typeDescription
idsquerystring or list of stringsPolicy IDs to retrieve.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_policy(ids=id_list)
print(response)

Given an array of policy IDs, returns detailed policies information.

GET /settings/entities/policy-details/v2
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_policy_details
NameTypeData typeDescription
idsquerystring or list of stringsDetection IDs to retrieve.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_policy_details(ids=id_list)
print(response)

Returns information about current policy settings.

GET /settings/entities/policy/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_policy_settings
NameTypeData typeDescription
cloud_platformquerystringCloud Provider (azure, aws, gcp).
parametersquerydictionaryFull query string parameters payload in JSON format.
policy_idquerystringIOA Policy ID.
servicequerystringFilter by Service type.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_policy_settings(policy_id="string",
cloud_platform="string",
service="string")
print(response)

Updates a policy setting - can be used to override policy severity or to disable a policy entirely.

PATCH /settings/entities/policy/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 update_policy_settings
NameTypeData typeDescription
account_idbodystringCloud Account ID to impact.
bodybodydictionaryFull body payload in JSON format.
enabledbodybooleanFlag indicating if this policy is enabled.
policy_idbodyintegerPolicy ID to be updated.
regionsbodystring or list of stringsList of regions where this policy is enforced.
severitybodystringPolicy severity value.
tag_excludedbodybooleanTag exclusion flag.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.update_policy_settings(account_id="string",
account_ids=id_list,
enabled=boolean,
policy_id=integer,
region=id_list,
severity="string",
tag_excluded=boolean)
print(response)

Returns scan schedule configuration for one or more cloud platforms.

GET /settings/scan-schedule/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_scan_schedule
NameTypeData typeDescription
cloud_platformquerystring or list of stringsThe Cloud Platform. (azure, aws, gcp)
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_scan_schedule(cloud_platform="string")
print(response)

Updates scan schedule configuration for one or more cloud platforms.

POST /settings/scan-schedule/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 update_scan_schedule
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
cloud_platformbodystringCloud platform (Azure, AWS, GCP).
next_scan_timestampbodystringUTC formatted string.
scan_schedulebodystringScan schedule type.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_scan_schedule(cloud_platform="string",
next_scan_timestamp="string",
scan_interval="string",
scan_schedule="string")
print(response)

Return information about Azure management group registration

GET /cloud-connect-cspm-azure/entities/management-group/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_azure_management_group
NameTypeData typeDescription
limitqueryintegerThe maximum records to return. Defaults to 100.
offsetqueryintegerThe offset to start retrieving records from
tenant_idsquerystring or list of stringsTenant ids to filter azure accounts
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_azure_management_group(limit=integer,
offset=integer,
tenant_ids=id_list)
print(response)

Deletes Azure management groups from the system.

DELETE /cloud-connect-cspm-azure/entities/management-group/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 delete_azure_management_group
NameTypeData typeDescription
parametersquerydictionaryFull query string parameters payload in JSON format.
tenant_idsquerystring or list of stringsTenant IDs to remove.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_azure_management_group(tenant_ids=id_list)
print(response)

Creates a new management group in our system for a customer.

POST /cloud-connect-cspm-azure/entities/management-group/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 create_azure_management_group
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
default_subscription_idbodystringAWS Account ID.
tenant_idbodystringAWS Account ID.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.create_azure_management_group(default_subscription_id="string",
tenant_id="string")
print(response)

Creates a new account and generates a new service account to add access to your GCP environment.

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

POST /cloud-connect-cspm-gcp/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 create_gcp_account
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
parent_idbodystringParent ID.
parent_typebodystringParent Type.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.create_gcp_account(parent_id="string", parent_type="string")
print(response)

Deletes a GCP account from the system.

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

DELETE /cloud-connect-cspm-gcp/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 delete_gcp_account
NameTypeData typeDescription
idsquerystring or list of stringsHierarchical Resource IDs of accounts to delete.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_gcp_account(ids=id_list)
print(response)

Updates an existing GCP account.

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

PATCH /cloud-connect-cspm-gcp/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 update_gcp_account
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
environmentbodystringEnvironment.
parent_idbodystringParent ID.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_gcp_account(environment="string", parent_id="string")
print(response)

Creates a new GCP account with newly-uploaded service account or connects with existing service account with only the following fields: parent_id, parent_type and service_account_id

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

POST /cloud-connect-cspm-gcp/entities/account/v2
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 connect_gcp_account
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
client_emailbodystringGCP client email.
client_idbodystringGCP client ID.
parent_idbodystringParent ID.
parent_typebodystringParent type.
private_keybodystringGCP private key.
private_key_idbodystringGCP private key ID.
project_idbodystringGCP project ID.
service_account_idbodyintegerGCP service account ID.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.connect_gcp_account(client_email="string",
client_id="string",
parent_id="string",
parent_type="string",
private_key="string",
private_key_id="string",
project_id="string",
service_account_id=integer)
print(response)

Returns the service account id and client email for external clients.

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

GET /cloud-connect-cspm-gcp/entities/service-accounts/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_gcp_service_account
NameTypeData typeDescription
idquerystringService account ID to retrieve.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_gcp_service_account(id="string")
print(response)

Updates an existing GCP service account.

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

PATCH /cloud-connect-cspm-gcp/entities/service-accounts/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 update_gcp_service_account
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
client_emailbodystringClient email associated with the account.
client_idbodystringGCP Client ID.
private_keybodystringGCP private key.
private_key_idbodystringGCP private key ID.
project_idbodystringGCP project ID.
service_account_conditionsbodylist of dictionariesGCP service account conditions.
service_account_idbodyintegerGCP service account ID.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_gcp_service_account(client_email="string",
client_id="string",
private_key="string",
private_key_id="string",
project_id="string",
resources=[{"key": "value"}],
service_account_conditions=[{"key": "value"}],
service_account_id=integer)
print(response)

Return a script for customer to run in their cloud environment to grant us access to their GCP environment as a downloadable attachment

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

GET /cloud-connect-cspm-gcp/entities/user-scripts-download/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_gcp_user_scripts_attachment
NameTypeData typeDescription
idsquerystring or list of stringsHierarchical Resource IDs of accounts.
parametersquerydictionaryFull query string parameters payload in JSON format.
parent_typequerystringGCP Hierarchy Parent Type. Allowed values: organization, folder or project
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
with open("output_file", "wb") as save_file:
response = falcon.get_gcp_user_scripts_attachment(ids=id_list,
parent_type="string",
stream=boolean)
save_file.write(response)

Run a synchronous health check.

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

POST /cloud-connect-cspm-gcp/entities/account/validate/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 validate_gcp_account
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
resourcesbodystring or list of stringsGCP Account IDs to validate.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.validate_gcp_account(resources=id_list)
print(response)

Validates credentials for a service account

This operation has been deprecated and will be removed from the SDK when this endpoint is decommissioned.

POST /cloud-connect-cspm-gcp/entities/service-accounts/validate/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 validate_gcp_service_account
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
client_emailbodystringClient email associated with the service account.
client_idbodystringGCP Client ID.
private_keybodystringGCP private key.
private_key_idbodystringGCP private key ID.
project_idbodystringGCP project ID.
resourcesbodylist of dictionariesList of GCP service accounts to validate. Overrides other keywords except for body if used.
service_account_conditionsbodylist of dictionariesGCP service account conditions.
service_account_idbodyintegerGCP service account ID.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
resources = [
{
"client_email": "string",
"client_id": "string",
"private_key": "string",
"private_key_id": "string",
"project_id": "string",
"service_account_conditions": [
{
"last_transition": "2024-03-19T22:48:28.987Z",
"message": "string",
"reason": "string",
"status": "string",
"type": "string"
}
],
"service_account_id": 0
}
]
response = falcon.validate_gcp_service_account(client_email="string",
client_id="string",
private_key="string",
private_key_id="string",
project_id="string",
resources=resources,
service_account_conditions=[{"key": "value"}],
service_account_id=integer)
print(response)

Returns information about the current status of an GCP account.

GET /cloud-connect-cspm-gcp/entities/account/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_gcp_account
NameTypeData typeDescription
idsquerylistHierarchical Resource IDs of accounts
limitqueryintegerThe maximum records to return. Defaults to 100.
offsetqueryintegerThe offset to start retrieving records from
parametersquerydictionaryFull query string parameters payload in JSON format.
parent_typequerystringGCP Hierarchy Parent Type, organization/folder/project
scan_typequerystringType of scan, dry or full, to perform on selected accounts
sortquerystringOrder fields in ascending or descending order. Ex: parent_type|asc.
statusquerystringAccount status to filter results by.

Examples coming soon.


Patches a existing account in our system for a customer.

PATCH /cloud-connect-cspm-azure/entities/account/v1
Scope CSPM Registration: WRITE Consumes · Produces application/json
PEP 8 update_azure_account
NameTypeData typeDescription
bodybodystring
parametersquerydictionaryFull query string parameters payload in JSON format.
bodybodydictionaryFull body payload as a JSON formatted dictionary.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_azure_account(account_type="string",
client_id="string",
default_subscription=boolean,
subscription_id="string",
tenant_id="string",
years_valid=integer)
print(response)

Get list of related cloud event LogScale IDs for a given IOA

GET /detects/queries/cloud-events/v1
Scope CSPM Registration: READ Consumes · Produces application/json
PEP 8 get_cloud_event_ids
NameTypeData typeDescription
idquerystringIOA Aggregate Event ID
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CSPMRegistration
falcon = CSPMRegistration(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_cloud_event_ids(id="string")
print(response)